var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter } from '@angular/core';
import { Collapse } from '../../animations/Collapse/Collapse';
export let AccordionItem = class AccordionItem {
    constructor() {
        this.disabled = false;
        this.openChange = new EventEmitter();
    }
    ngOnInit() {
    }
    toggleOpen(event) {
        event.preventDefault();
        if (!this.disabled) {
            this.open = !this.open;
            this.openChange.next(this.open);
        }
    }
};
__decorate([
    Input(), 
    __metadata('design:type', String)
], AccordionItem.prototype, "heading", void 0);
__decorate([
    Input(), 
    __metadata('design:type', Boolean)
], AccordionItem.prototype, "disabled", void 0);
__decorate([
    Output(), 
    __metadata('design:type', Object)
], AccordionItem.prototype, "openChange", void 0);
__decorate([
    Input(), 
    __metadata('design:type', Boolean)
], AccordionItem.prototype, "open", void 0);
AccordionItem = __decorate([
    Component({
        selector: 'accordion-item, [accordion-item]',
        template: "\n      <div (click)=\"toggleOpen($event)\">\n          <span *ngIf=\"heading\" class=\"fuel-ui-clickable\" \n              [ngClass]=\"{'text-muted': disabled}\">\n              {{heading}}\n          </span>\n          <ng-content select=\"accordion-heading\"></ng-content>\n          <ng-content select=\"[accordion-heading]\"></ng-content>\n      </div>\n      <div class=\"fuel-ui-collapse\" [@collapse]=\"!open ? 'true' : 'false'\">\n          <ng-content></ng-content>\n      </div>\n    ",
        animations: [Collapse(350)]
    }), 
    __metadata('design:paramtypes', [])
], AccordionItem);
