import { OnInit, AfterContentInit, ChangeDetectorRef, Renderer } from '@angular/core';
import { EventEmitter, QueryList } from '@angular/core';
import { DatePickerField, DatePickerFieldStyler } from "./DatePickerField";
import { InfiniteScroller } from "../InfiniteScroller/InfiniteScroller";
export declare class DatePicker implements OnInit, AfterContentInit {
    _minDate: Date;
    _maxDate: Date;
    minDate: Date | string;
    maxDate: Date | string;
    dateFilter: (d: Date) => boolean;
    valueChange: EventEmitter<{}>;
    value: any;
    inputDate: string;
    calendarScroller: InfiniteScroller;
    dateField: DatePickerField;
    dateFieldIcons: QueryList<DatePickerFieldStyler>;
    protected _selectedDate: Date;
    selectedDate: Date;
    calendarDisplayed: boolean;
    calendarX: string;
    calendarY: string;
    calendarHeight: string;
    calendarMonths: Date[];
    _preGenMonths: number;
    changeDetector: ChangeDetectorRef;
    renderer: Renderer;
    initialScroll: boolean;
    constructor(changeDetector: ChangeDetectorRef, renderer: Renderer);
    ngOnInit(): void;
    ngAfterContentInit(): void;
    generateMonths(): void;
    scrollerReset(): void;
    toggleCalendar(event: Event): void;
    showCalendar(event: Event): void;
    hideCalendar(): void;
    canPrevMonth: boolean;
    canNextMonth: boolean;
    disablePrev(): boolean;
    disableNext(): boolean;
    scrollPrevMonth(): void;
    scrollNextMonth(): void;
    addNextMonth(): void;
    addPrevMonth(): void;
}
