var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Directive, Input, Output, HostBinding, HostListener, EventEmitter } from "@angular/core";
import { DateUtils } from "../../utilities/utilities";
export let DatePickerField = class DatePickerField {
    constructor() {
        this._date = new Date();
        this._value = "";
        this.valueChange = new EventEmitter();
        this.ngModelChange = new EventEmitter();
        this.dateChange = new EventEmitter();
        this.select = new EventEmitter();
    }
    set value(value) {
        if (value == this._value)
            return;
        this._value = value;
        this._date = DateUtils.handleDateInput(value);
        this.valueChange.next(value);
        this.ngModelChange.next(value);
        this.dateChange.next(this._date);
    }
    get value() { return this._value; }
    set ngModel(value) {
        this.value = value;
    }
    set date(date) {
        if (date.getTime() == this._date.getTime())
            return;
        this._date = date;
        this._value = date.toLocaleDateString();
        this.dateChange.next(date);
        this.ngModelChange.next(this._value);
        this.valueChange.next(this._value);
    }
    get date() { return this._date; }
    inputChange(value) {
        this.value = value;
    }
    focused(event) {
        this.select.next(event);
    }
    selected(event) {
        this.select.next(event);
    }
    ngOnInit() {
        this.date = DateUtils.handleDateInput(this.value);
    }
};
__decorate([
    HostBinding("value"), 
    __metadata('design:type', Object)
], DatePickerField.prototype, "_value", void 0);
__decorate([
    Input(), 
    __metadata('design:type', String), 
    __metadata('design:paramtypes', [String])
], DatePickerField.prototype, "value", null);
__decorate([
    Output(), 
    __metadata('design:type', Object)
], DatePickerField.prototype, "valueChange", void 0);
__decorate([
    Input(), 
    __metadata('design:type', Object), 
    __metadata('design:paramtypes', [Object])
], DatePickerField.prototype, "ngModel", null);
__decorate([
    Output(), 
    __metadata('design:type', Object)
], DatePickerField.prototype, "ngModelChange", void 0);
__decorate([
    Input(), 
    __metadata('design:type', Date), 
    __metadata('design:paramtypes', [Date])
], DatePickerField.prototype, "date", null);
__decorate([
    Output(), 
    __metadata('design:type', Object)
], DatePickerField.prototype, "dateChange", void 0);
__decorate([
    HostListener("input", ["$event.target.value"]), 
    __metadata('design:type', Function), 
    __metadata('design:paramtypes', [Object]), 
    __metadata('design:returntype', void 0)
], DatePickerField.prototype, "inputChange", null);
__decorate([
    HostListener("focus", ["$event"]), 
    __metadata('design:type', Function), 
    __metadata('design:paramtypes', [Event]), 
    __metadata('design:returntype', void 0)
], DatePickerField.prototype, "focused", null);
__decorate([
    Output(), 
    __metadata('design:type', Object)
], DatePickerField.prototype, "select", void 0);
__decorate([
    HostListener("click", ["$event"]), 
    __metadata('design:type', Function), 
    __metadata('design:paramtypes', [MouseEvent]), 
    __metadata('design:returntype', void 0)
], DatePickerField.prototype, "selected", null);
DatePickerField = __decorate([
    Directive({
        selector: "[dateField], .date-field"
    }), 
    __metadata('design:paramtypes', [])
], DatePickerField);
export let DatePickerFieldStyler = class DatePickerFieldStyler {
    constructor() {
        this.selectEvent = new EventEmitter();
    }
    select(event) {
        this.selectEvent.next(event);
    }
};
DatePickerFieldStyler = __decorate([
    Component({
        selector: ".date-picker-input-group",
        template: ` 
    <div class="input-group fuel-ui-datepicker-input-group">
        <ng-content></ng-content>
        <span class="input-group-addon" (click)="select($event)"> 
            <i class="fa fa-calendar"></i>
        </span>
    </div>`
    }), 
    __metadata('design:paramtypes', [])
], DatePickerFieldStyler);
