var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { NgModule, Component, ElementRef, Input, Output, EventEmitter } from '@angular/core';
import { CommonModule } from "@angular/common";
import { FuiAnimationModule } from "../../directives/Animation/Animation";
export let Modal = class Modal {
    constructor(el) {
        this.displayed = false;
        this.closeOnUnfocus = true;
        this.closeButton = true;
        this.modalTitle = '';
        this.size = '';
        this.close = new EventEmitter();
        this.open = new EventEmitter();
        this._el = el.nativeElement;
    }
    clickElement(e) {
        if (this.closeOnUnfocus) {
            if ((e.target && (e.target.className == 'modal customFadeIn' || e.target.className == 'modal-dialog'))
                || (e.srcElement && (e.srcElement.className == 'modal customFadeIn' || e.srcElement.className == 'modal-dialog')))
                this.closeModal();
        }
    }
    getElement() {
        return this._el;
    }
    closeModal() {
        this.showModal(false);
        this.close.next(null);
        return false;
    }
    showModal(isDisplayed) {
        var body = document.body;
        if (isDisplayed === undefined) {
            this.displayed = !this.displayed;
        }
        else {
            this.displayed = isDisplayed;
        }
        if (this.displayed) {
            body.classList.add('modal-open');
            this.open.next(null);
        }
        else {
            body.classList.remove('modal-open');
            if (this.closeOnUnfocus) {
                this._el.childNodes[0].removeEventListener('click', (e) => {
                    if ((e.target && (e.srcElement.className == 'modal customFadeIn' || e.srcElement.className == 'modal-dialog'))
                        || (e.srcElement && (e.srcElement.className == 'modal customFadeIn' || e.srcElement.className == 'modal-dialog')))
                        this.showModal(false);
                });
            }
        }
        return false;
    }
};
__decorate([
    Input(), 
    __metadata('design:type', Boolean)
], Modal.prototype, "closeOnUnfocus", void 0);
__decorate([
    Input(), 
    __metadata('design:type', Boolean)
], Modal.prototype, "closeButton", void 0);
__decorate([
    Input(), 
    __metadata('design:type', String)
], Modal.prototype, "modalTitle", void 0);
__decorate([
    Input(), 
    __metadata('design:type', String)
], Modal.prototype, "size", void 0);
__decorate([
    Output(), 
    __metadata('design:type', EventEmitter)
], Modal.prototype, "close", void 0);
__decorate([
    Output(), 
    __metadata('design:type', EventEmitter)
], Modal.prototype, "open", void 0);
Modal = __decorate([
    Component({
        selector: 'modal',
        host: {
            '(click)': 'clickElement($event)'
        },
        template: "\n   <div class=\"modal\" [ngClass]=\"{'fuel-ui-modal-fade-in': displayed}\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myModalLabel\" aria-hidden=\"true\" [style.display]=\"displayed ? 'block' : 'none'\">\n       <div class=\"modal-dialog\" role=\"document\" [ngClass]=\"{'modal-lg': size == 'large' || size == 'lg', 'modal-sm': size == 'small' || size == 'sm'}\">\n           <div class=\"modal-content\">\n               <div class=\"modal-header\">\n                   <button *ngIf=\"closeButton\" type=\"button\" class=\"close\" aria-label=\"Close\" (click)=\"closeModal()\">\n                       <span aria-hidden=\"true\">&#215;</span>\n                       <span class=\"sr-only\">Close</span>\n                   </button>\n                   <h4 class=\"modal-title\" id=\"myModalLabel\">{{modalTitle}}</h4>\n               </div>\n               <ng-content></ng-content>\n           </div>\n       </div>\n   </div>\n   <div class=\"modal-backdrop\" [ngClass]=\"{fade: displayed, in: displayed}\" [style.display]=\"displayed ? 'block' : 'none'\"></div>\n    "
    }), 
    __metadata('design:paramtypes', [ElementRef])
], Modal);
export let FuiModalModule = class FuiModalModule {
};
FuiModalModule = __decorate([
    NgModule({
        imports: [CommonModule, FuiAnimationModule],
        declarations: [Modal],
        exports: [Modal]
    }), 
    __metadata('design:paramtypes', [])
], FuiModalModule);
