var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { NgModule, Directive, Input, Output, HostBinding, EventEmitter } from "@angular/core";
import { CommonModule } from "@angular/common";
import { TabSet } from "./TabSet";
export let Tab = class Tab {
    constructor(tabset) {
        this.activeChange = new EventEmitter(false);
        this.select = new EventEmitter(false);
        this.deselect = new EventEmitter(false);
        this.remove = new EventEmitter(false);
        this.addClass = true;
        this.tabset = tabset;
        this.tabset.addTab(this);
    }
    /** tab active state toggle */
    get active() {
        return this._active;
    }
    set active(active) {
        if (this.disabled && active || !active) {
            //Only emit deselect event when changing
            if (this._active && this._active != active) {
                this.deselect.next(this);
            }
            if (!active) {
                this._active = active;
            }
            this.activeChange.next(this._active);
            return;
        }
        //Only emit select event when changing
        if (this._active != active) {
            this.select.next(this);
        }
        this._active = active;
        this.activeChange.next(this._active);
        this.tabset.tabs.forEach((tab) => {
            if (tab !== this) {
                tab.active = false;
                tab.activeChange.next(false);
            }
        });
    }
    ngOnDestroy() {
        this.tabset.removeTab(this);
    }
};
__decorate([
    Input(), 
    __metadata('design:type', String)
], Tab.prototype, "heading", void 0);
__decorate([
    Input(), 
    __metadata('design:type', Boolean)
], Tab.prototype, "disabled", void 0);
__decorate([
    Input(), 
    __metadata('design:type', Boolean)
], Tab.prototype, "removable", void 0);
__decorate([
    HostBinding('class.active'),
    Input(), 
    __metadata('design:type', Boolean)
], Tab.prototype, "active", null);
__decorate([
    Output(), 
    __metadata('design:type', EventEmitter)
], Tab.prototype, "activeChange", void 0);
__decorate([
    Output(), 
    __metadata('design:type', EventEmitter)
], Tab.prototype, "select", void 0);
__decorate([
    Output(), 
    __metadata('design:type', EventEmitter)
], Tab.prototype, "deselect", void 0);
__decorate([
    Output(), 
    __metadata('design:type', EventEmitter)
], Tab.prototype, "remove", void 0);
__decorate([
    HostBinding('class.tab-pane'), 
    __metadata('design:type', Boolean)
], Tab.prototype, "addClass", void 0);
Tab = __decorate([
    Directive({
        selector: 'tab, [tab]'
    }), 
    __metadata('design:paramtypes', [TabSet])
], Tab);
const tabComponents = [
    Tab,
    TabSet
];
export let FuiTabModule = class FuiTabModule {
};
FuiTabModule = __decorate([
    NgModule({
        imports: [CommonModule],
        declarations: tabComponents,
        exports: tabComponents
    }), 
    __metadata('design:paramtypes', [])
], FuiTabModule);
