var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component } from '@angular/core';
import { Event, EventColumns, EventsDefaultSort, Attribute, AttributeColumns, AttributesDefaultSort } from '../../utilities/demoUtilities';
export let TextExpanderDemo = class TextExpanderDemo {
    constructor() {
        this.expanded = false;
        this.ellipsis = true;
        this.text = "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum sed massa sed odio gravida iaculis. Sed elementum dapibus neque, sit.";
        this.characters = 50;
        this.words = 0;
        this.expandText = "Show more";
        this.shrinkText = "Show less";
        this.attributes = [
            new Attribute('expanded', 'boolean', 'false', 'The current state of whether or not the complete text is displayed'),
            new Attribute('ellipsis', 'boolean', 'true', 'Add "..." at the end of the text when not expanded'),
            new Attribute('text', 'string', 'null', 'The text that can be expanded/shrunk'),
            new Attribute('characters', 'number', '50', 'The number of characters displayed when text is shrunk'),
            new Attribute('words', 'number', '0', 'The number of words displayed when text is shrunk. If set to 0, characters are defaulted to'),
            new Attribute('expandText', 'string', 'show more', 'Clickable text used to expand text'),
            new Attribute('shrinkText', 'string', 'show less', 'Clickable text used to shrink text')
        ];
        this.attributesColumns = AttributeColumns;
        this.attributesSort = AttributesDefaultSort;
        this.events = [
            new Event('expandedChange', '$event = expanded: boolean', 'New state of whether the text is expanded or not')
        ];
        this.eventsColumns = EventColumns;
        this.eventsSort = EventsDefaultSort;
    }
};
TextExpanderDemo = __decorate([
    Component({
        template: "\n    <div class=\"row\">\n        <div class=\"col-md-12\">\n            <div class=\"card card-block\">\n                <h2 class=\"card-title\">TextExpander</h2>\n                <p class=\"card-text\">TextExpander is a custom component to display a text expander number list</p>\n            </div>\n        </div>\n    </div>\n\n    <section class=\"row m-a\">\n        <div class=\"col-md-8\">\n            <form>\n                <div class=\"form-group row\">\n                    <label for=\"text\" class=\"col-sm-2 form-control-label\">Text</label>\n                    <div class=\"col-sm-12\">\n                        <input class=\"form-control\" [(ngModel)]=\"text\" type=\"text\" name=\"text\">\n                    </div>\n                </div>\n                <div class=\"form-group row\">\n                    <label for=\"characters\" class=\"col-sm-2 form-control-label\">Characters</label>\n                    <div class=\"col-sm-2\">\n                        <input class=\"form-control\" [(ngModel)]=\"characters\" min=\"1\" type=\"number\" name=\"characters\">\n                    </div>\n                </div>\n                <div class=\"form-group row\">\n                    <label for=\"words\" class=\"col-sm-2 form-control-label\">Words</label>\n                    <div class=\"col-sm-2\">\n                        <input class=\"form-control\" [(ngModel)]=\"words\" min=\"0\" type=\"number\" name=\"words\">\n                    </div>\n                    <small class=\"text-muted\">Expander defaults to number of characters when set to 0.</small>\n                </div>\n                <div class=\"form-group row\">\n                    <label for=\"expandText\" class=\"col-sm-2 form-control-label\">Expand Text</label>\n                    <div class=\"col-sm-6\">\n                        <input class=\"form-control\" [(ngModel)]=\"expandText\" type=\"text\" name=\"expandText\">\n                    </div>\n                </div>\n                <div class=\"form-group row\">\n                    <label for=\"expandText\" class=\"col-sm-2 form-control-label\">Shrink Text</label>\n                    <div class=\"col-sm-6\">\n                        <input class=\"form-control\" [(ngModel)]=\"shrinkText\" type=\"text\" name=\"shrinkText\">\n                    </div>\n                </div>\n                <div class=\"row\">\n                    <div class=\"checkbox col-md-3\">\n                        <label for=\"expanded\" class=\"form-control-label\">\n                            <input [(ngModel)]=\"expanded\" type=\"checkbox\" name=\"expanded\" /> \n                            Expanded\n                        </label>\n                    </div>\n                </div>\n                <div class=\"row\">\n                    <div class=\"checkbox col-md-3\">\n                        <label for=\"ellipsis\" class=\"form-control-label\">\n                            <input [(ngModel)]=\"ellipsis\" type=\"checkbox\" name=\"ellipsis\" /> \n                            Ellipsis\n                        </label>\n                    </div>\n                </div>\n            </form>\n            <text-expander\n                [(expanded)]=\"expanded\"\n                [ellipsis]=\"ellipsis\"\n                [text]=\"text\"\n                [characters]=\"characters\"\n                [words]=\"words\"\n                [expandText]=\"expandText\"\n                [shrinkText]=\"shrinkText\">\n            </text-expander>\n        </div>\n    </section>\n\n    <div class=\"source\">\n    <h3>Import</h3>\n    <pre>\n    <code class=\"language-javascript\" code-highlight>\n    import {{'{'}}TextExpander{{'}'}} from 'fuel-ui/fuel-ui';\n    </code>\n    </pre>\n\n    <h3>Getting Started</h3>\n    <p>TextExpander is a custom element to show an interactive list of page numbers to use for paging</p>\n\n    <h3>Usage</h3>\n    <tabset>\n    <tab heading=\"HTML\">\n    <pre>\n    <code class=\"language-markup\" code-highlight>\n    &lt;text-expander\n        [(expanded)]=&quot;expanded&quot;\n        [ellipsis]=&quot;ellipsis&quot;\n        [text]=&quot;text&quot;\n        [words]=&quot;words&quot;\n        [characters]=&quot;characters&quot;\n        [expandText]=&quot;expandText&quot;\n        [shrinkText]=&quot;shrinkText&quot;&gt;\n    &lt;/text-expander&gt;\n    </code>\n    </pre>\n    </tab>\n    <tab heading=\"TypeScript\">\n    <pre>\n    <code class=\"language-javascript\" code-highlight>\n    export class TextExpanderExample {{'{'}}\n        expanded: boolean = false;\n        ellipsis: boolean = true;\n        text: string = \"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum sed \" + \n                        \"massa sed odio gravida iaculis. Sed elementum dapibus neque, sit.\";\n        characters: number = 50;\n        words: number = 0;\n        expandText: string = \"Show more\";\n        shrinkText: string = \"Show less\";\n    {{'}'}}\n    </code>\n    </pre>\n    </tab>\n    </tabset>\n\n    <h3>Attributes</h3>\n    <table-sortable\n        [columns]=\"attributesColumns\"\n        [data]=\"attributes\"\n        [sort]=\"attributesSort\">\n        Loading table...\n    </table-sortable>\n\n    <h3>Events</h3>\n    <table-sortable\n        [columns]=\"eventsColumns\"\n        [data]=\"events\"\n        [sort]=\"eventsSort\">\n        Loading table...\n    </table-sortable>\n\n    </div>\n  "
    }), 
    __metadata('design:paramtypes', [])
], TextExpanderDemo);
