var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { NgModule, Directive, Input, Output, EventEmitter, ElementRef } from '@angular/core';
export let Animation = class Animation {
    constructor(element) {
        this.onAnimationStart = new EventEmitter();
        this.onAnimationEnd = new EventEmitter();
        this.animationClasses = '';
        this.play = false;
        this.id = ''; // use for query filtering
        this.group = ''; // use for query filtering
        this._animationQueue = [];
        this._callbacks = [];
        this.element = element.nativeElement;
    }
    ngOnChanges() {
        this.setup();
    }
    ngOnInit() {
        this.setup();
    }
    addAnimation(animationClasses) {
        animationClasses.split(' ')
            .map(c => this._animationQueue.push(c));
        this.animationClasses += " " + animationClasses;
        return this;
    }
    setup() {
        this._animationQueue = this.animationClasses
            .split(" ")
            .filter((c) => c.length > 0);
        if (this.play && this._animationQueue.length > 0)
            this.startAnimation();
        return this;
    }
    startAnimation(callback = null) {
        if (callback != null)
            this._callbacks.push(callback);
        this._animationQueue.shift()
            .split('.')
            .filter((c) => c.length > 0)
            .map((c) => this.element.classList.add(c));
        return this;
    }
    cleanAnimation() {
        this.animationClasses
            .replace('.', ' ')
            .split(' ')
            .filter((c) => c.length > 0)
            .map((c) => {
            this.element.classList.remove(c);
        });
        return this;
    }
    animationStarted(event) {
        this.onAnimationStart.next(null);
    }
    animationEnded(event) {
        this.cleanAnimation();
        if (this._animationQueue.length > 0) {
            this.startAnimation();
            return;
        }
        while (this._callbacks.length > 0)
            this._callbacks.shift()();
        this.onAnimationEnd.next(null);
    }
};
__decorate([
    Output(), 
    __metadata('design:type', Object)
], Animation.prototype, "onAnimationStart", void 0);
__decorate([
    Output(), 
    __metadata('design:type', Object)
], Animation.prototype, "onAnimationEnd", void 0);
__decorate([
    Input('animation'), 
    __metadata('design:type', String)
], Animation.prototype, "animationClasses", void 0);
__decorate([
    Input(), 
    __metadata('design:type', Boolean)
], Animation.prototype, "play", void 0);
__decorate([
    Input(), 
    __metadata('design:type', String)
], Animation.prototype, "id", void 0);
__decorate([
    // use for query filtering
    Input(), 
    __metadata('design:type', String)
], Animation.prototype, "group", void 0);
Animation = __decorate([
    Directive({
        selector: '[animation]',
        host: {
            '(animationstart)': 'animationStarted($event)',
            '(webkitAnimationStart)': 'animationStarted($event)',
            '(oanimationstart)': 'animationStarted($event)',
            '(MSAnimationStart)': 'animationStarted($event)',
            '(animationend)': 'animationEnded($event)',
            '(webkitAnimationEnd)': 'animationEnded($event)',
            '(oanimationend)': 'animationEnded($event)',
            '(MSAnimationEnd)': 'animationEnded($event)'
        }
    }), 
    __metadata('design:paramtypes', [ElementRef])
], Animation);
export let FuiAnimationModule = class FuiAnimationModule {
};
FuiAnimationModule = __decorate([
    NgModule({
        declarations: [Animation],
        exports: [Animation]
    }), 
    __metadata('design:paramtypes', [])
], FuiAnimationModule);
