"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var common_1 = require("@angular/common");
var AccordionItem_1 = require('./AccordionItem');
var Collapse_1 = require('../../animations/Collapse/Collapse');
var Accordion = (function () {
    function Accordion() {
        this.closeOthers = true;
        this.duration = 250;
        this.itemEvents = [];
    }
    Accordion.prototype.ngAfterContentInit = function () {
        var _this = this;
        this.items.changes.subscribe(function (i) { return _this.registerItems(); });
        this.registerItems();
    };
    Accordion.prototype.registerItems = function () {
        var _this = this;
        for (var _i = 0, _a = this.itemEvents; _i < _a.length; _i++) {
            var event_1 = _a[_i];
            event_1.unsubscribe();
        }
        var _loop_1 = function(item) {
            item.openChange.subscribe(function () {
                _this.closeOtherItems(item);
            });
        };
        for (var _b = 0, _c = this.items.toArray(); _b < _c.length; _b++) {
            var item = _c[_b];
            _loop_1(item);
        }
    };
    Accordion.prototype.closeOtherItems = function (openItem) {
        if (!this.closeOthers)
            return;
        this.items.forEach(function (item) {
            if (item !== openItem) {
                item.open = false;
            }
        });
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], Accordion.prototype, "closeOthers", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], Accordion.prototype, "duration", void 0);
    __decorate([
        core_1.ContentChildren(AccordionItem_1.AccordionItem), 
        __metadata('design:type', core_1.QueryList)
    ], Accordion.prototype, "items", void 0);
    Accordion = __decorate([
        core_1.Component({
            selector: 'accordion',
            template: "<ng-content></ng-content>",
            animations: [Collapse_1.Collapse(350)]
        }), 
        __metadata('design:paramtypes', [])
    ], Accordion);
    return Accordion;
}());
exports.Accordion = Accordion;
var accordionComponents = [
    Accordion,
    AccordionItem_1.AccordionItem
];
var FuiAccordionModule = (function () {
    function FuiAccordionModule() {
    }
    FuiAccordionModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule],
            declarations: accordionComponents,
            exports: accordionComponents
        }), 
        __metadata('design:paramtypes', [])
    ], FuiAccordionModule);
    return FuiAccordionModule;
}());
exports.FuiAccordionModule = FuiAccordionModule;

//# sourceMappingURL=Accordion.js.map
