import { QueryList, ElementRef } from "@angular/core";
import { AfterContentInit, AfterViewInit, AfterContentChecked, OnDestroy } from "@angular/core";
import { ChangeDetectorRef } from "@angular/core";
export declare class CarouselItem {
    private _change;
    id: any;
    private _state;
    state: "right" | "left" | "in" | "void";
    isActive: boolean;
    element: HTMLElement;
    constructor(_change: ChangeDetectorRef, element: ElementRef);
    getTotalHeight(): number;
}
export declare class Carousel implements AfterContentInit, AfterContentChecked, AfterViewInit, OnDestroy {
    private _change;
    hammerInitialized: boolean;
    items: CarouselItem[];
    private _activeIndex;
    activeIndex: number;
    interval: number;
    _intervalRef: any;
    innerHeight: number;
    itemQuery: QueryList<CarouselItem>;
    panDirection: number;
    lastPanOffset: number;
    element: HTMLElement;
    constructor(_change: ChangeDetectorRef, element: ElementRef);
    ngAfterContentInit(): void;
    ngAfterContentChecked(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    registerItems(): void;
    updateInnerHeight(): void;
    getRelativeItem(rel: number): CarouselItem;
    getRelativeIndex(rel: number): number;
    navigateTo(item: CarouselItem): void;
    prev(item?: CarouselItem): void;
    next(item?: CarouselItem): void;
    swipeleft(): void;
    swiperight(): void;
}
export declare class FuiCarouselModule {
}
