import { ChangeDetectorRef, Renderer } from '@angular/core';
import { AfterContentInit } from "@angular/core";
import { EventEmitter, ElementRef, QueryList } from '@angular/core';
import { DateRange } from "../../utilities/utilities";
import { DatePicker } from "./DatePicker";
import { DatePickerField, DatePickerFieldStyler } from "./DatePickerField";
import { InfiniteScroller } from "../InfiniteScroller/InfiniteScroller";
export declare class StartDateField extends DatePickerField {
    element: ElementRef;
    constructor(element: ElementRef);
}
export declare class EndDateField extends DatePickerField {
    element: ElementRef;
    constructor(element: ElementRef);
}
export declare class DateRangePicker extends DatePicker implements AfterContentInit {
    valueChange: EventEmitter<{}>;
    value: any;
    minDate: Date | string;
    maxDate: Date | string;
    dateFilter: (d: Date) => boolean;
    calendarScroller: InfiniteScroller;
    startDateField: StartDateField;
    endDateField: EndDateField;
    dateFieldIcons: QueryList<DatePickerFieldStyler>;
    private _dateTarget;
    calendarHeight: string;
    selectedDate: Date;
    inputStartDate: string;
    inputEndDate: string;
    private _startDate;
    private _endDate;
    startDateChange: EventEmitter<{}>;
    startDate: any;
    endDateChange: EventEmitter<{}>;
    endDate: any;
    constructor(changeDetector: ChangeDetectorRef, renderer: Renderer);
    ngAfterContentInit(): void;
    selectDate(value: Date, target?: boolean): void;
    handleRangeInput(value: any): DateRange;
    focusStartDate(): void;
    focusEndDate(): void;
    checkStartDateTarget(): boolean;
    checkEndDateTarget(): boolean;
}
