"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
var OrderBy_1 = require("../../pipes/OrderBy/OrderBy");
var Format_1 = require("../../pipes/Format/Format");
var TableSortableSorting_1 = require("./TableSortableSorting");
var TableSortable = (function () {
    function TableSortable() {
    }
    TableSortable.prototype.selectedClass = function (column) {
        if (!column.sortable)
            return 'fuel-ui-not-sortable';
        return column.variable == this.sort.column ? 'sort-' + (this.sort.descending ? 'desc' : 'asc') : '';
    };
    TableSortable.prototype.changeSorting = function (column) {
        if (!column.sortable)
            return;
        var sort = this.sort;
        if (sort.column == column.variable) {
            sort.descending = !sort.descending;
        }
        else {
            sort.column = column.variable;
            sort.descending = false;
        }
    };
    TableSortable.prototype.convertSorting = function () {
        return this.sort.descending ? '-' + this.sort.column : this.sort.column;
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array)
    ], TableSortable.prototype, "columns", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array)
    ], TableSortable.prototype, "data", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', TableSortableSorting_1.TableSortableSorting)
    ], TableSortable.prototype, "sort", void 0);
    TableSortable = __decorate([
        core_1.Component({
            selector: 'table-sortable',
            template: "\n    <div class=\"table-responsive\">\n      <table class=\"table table-bordered table-hover table-striped fuel-ui-table-sortable\">\n        <thead>\n          <tr>\n            <th *ngFor=\"let column of columns\" [class]=\"selectedClass(column)\" (click)=\"changeSorting(column)\">\n              {{column.display}}\n            </th>\n          </tr>\n        </thead>\n        <tbody>\n          <tr *ngFor=\"let object of data | orderBy : convertSorting()\">\n            <td *ngFor=\"let column of columns\" [innerHtml]=\"object[column.variable] | format : column.filter\"></td>\n          </tr>\n        </tbody>\n      </table>\n    </div>\n  ",
            pipes: [common_1.JsonPipe]
        }), 
        __metadata('design:paramtypes', [])
    ], TableSortable);
    return TableSortable;
}());
exports.TableSortable = TableSortable;
var TableSortableColumn_1 = require("./TableSortableColumn");
exports.TableSortableColumn = TableSortableColumn_1.TableSortableColumn;
var TableSortableSorting_2 = require("./TableSortableSorting");
exports.TableSortableSorting = TableSortableSorting_2.TableSortableSorting;
var FuiTableSortableModule = (function () {
    function FuiTableSortableModule() {
    }
    FuiTableSortableModule = __decorate([
        core_1.NgModule({
            imports: [common_1.CommonModule, forms_1.FormsModule, Format_1.FuiFormatPipeModule, OrderBy_1.FuiOrderByPipeModule],
            declarations: [TableSortable],
            exports: [TableSortable]
        }), 
        __metadata('design:paramtypes', [])
    ], FuiTableSortableModule);
    return FuiTableSortableModule;
}());
exports.FuiTableSortableModule = FuiTableSortableModule;

//# sourceMappingURL=TableSortable.js.map
